/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.wahllokalsystem.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class WahllokalsystemStatusTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

  protected final de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK;
    public de.ivu.elect.business.gebietsbaum.entity.GebietTK getGebietTK(){
      return gebietTK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlTK wahlTK;
    public de.ivu.elect.business.wahl.entity.WahlTK getWahlTK(){
      return wahlTK;
    }

  public WahllokalsystemStatusTK(
  de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK
,   de.ivu.elect.business.wahl.entity.WahlTK wahlTK
  ) {
    super();


        this.gebietTK = gebietTK;
      this.wahlTK = wahlTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
        
                    result = result + ((gebietTK == null) ? 0 : gebietTK.hashCode());
                    result = result + ((wahlTK == null) ? 0 : wahlTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof WahllokalsystemStatusTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        WahllokalsystemStatusTK other = (WahllokalsystemStatusTK) obj;

        
                if (gebietTK == null) {
          if (other.gebietTK != null) {
            return false;
          }
        } else if (!gebietTK.equals(other.gebietTK)) {
          return false;
        }
                if (wahlTK == null) {
          if (other.wahlTK != null) {
            return false;
          }
        } else if (!wahlTK.equals(other.wahlTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return WahllokalsystemStatusConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietTK.getAllEntityFieldValues());
    result.addAll(wahlTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            return java.util.Collections.emptyList();
      }


            @Override
            public String toString() {
            return "WahllokalsystemStatusTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                                    +"gebietTK="+gebietTK
                            +", wahlTK="+wahlTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                                  +  toStringLokalisiert(gebietTK, messages)
                          + ", " +  toStringLokalisiert(wahlTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends WahllokalsystemStatus> java.util.Map<WahllokalsystemStatusTK, E> mappeWahllokalsystemStatusNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(WahllokalsystemStatus::getWahllokalsystemStatusTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<WahllokalsystemStatus, WahllokalsystemStatusTK> getWahllokalsystemStatusToTKFunction() {
                return WahllokalsystemStatus::getWahllokalsystemStatusTK;
                }

}
